import torch
from _typeshed import Incomplete
from torch._ops import OpOverloadPacket
from torch.export.decomp_utils import CustomDecompTable
from typing import Callable, Sequence

__all__ = ['decomposition_table', 'pre_autograd_decomposition_table', 'meta_table', 'register_decomposition', 'get_decompositions', 'core_aten_decompositions', '_should_decompose_because_unsafe_op']

decomposition_table: Incomplete
pre_autograd_decomposition_table: Incomplete
meta_table: Incomplete

def _should_decompose_because_unsafe_op(op: torch._ops.OperatorBase) -> bool: ...
def register_decomposition(aten_op, registry: Incomplete | None = None, *, type: str = 'post_autograd', unsafe: bool = False) -> Callable[[Callable[_P, _T]], Callable[_P, _T]]: ...
def get_decompositions(aten_ops: Sequence[torch._ops.OperatorBase | OpOverloadPacket], type: str = 'post_autograd') -> dict[torch._ops.OperatorBase, Callable]: ...
def core_aten_decompositions() -> CustomDecompTable: ...
