import dataclasses
import torch
import torch.fx
from _typeshed import Incomplete
from collections import OrderedDict as OrderedDict
from contextlib import contextmanager as contextmanager
from torch._dispatch.python import enable_python_dispatcher as enable_python_dispatcher
from torch._guards import compile_context as compile_context
from torch._utils_internal import log_export_usage as log_export_usage
from torch.export._tree_utils import reorder_kwargs as reorder_kwargs
from torch.export.graph_signature import ArgumentSpec as ArgumentSpec, ConstantArgument as ConstantArgument, ExportGraphSignature as ExportGraphSignature, InputKind as InputKind, InputSpec as InputSpec, OutputKind as OutputKind, OutputSpec as OutputSpec, SymBoolArgument as SymBoolArgument, SymFloatArgument as SymFloatArgument, SymIntArgument as SymIntArgument, TensorArgument as TensorArgument
from torch.fx._compatibility import compatibility as compatibility
from torch.fx.experimental.proxy_tensor import make_fx as make_fx
from typing import Any, Callable
from unittest.mock import patch as patch

log: Incomplete

@dataclasses.dataclass
class ExportDynamoConfig:
    allow_rnn: bool = ...

def capture_pre_autograd_graph_warning() -> None: ...
def print_export_warning() -> None: ...
def gm_using_training_ir(graph_module: torch.fx.GraphModule) -> bool: ...
def capture_pre_autograd_graph(f: torch.nn.Module, args: tuple[Any], kwargs: dict[str, Any] | None = None, dynamic_shapes: dict[str, Any] | tuple[Any] | None = None) -> torch.nn.Module: ...
def aot_compile_warning() -> None: ...
def aot_compile(f: Callable, args: tuple[Any], kwargs: dict[str, Any] | None = None, *, dynamic_shapes: dict[str, Any] | None = None, options: dict[str, Any] | None = None, remove_runtime_assertions: bool = False, disable_constraint_solver: bool = False, same_signature: bool = True) -> list[str] | str: ...
def aot_load(so_path: str, device: str) -> Callable: ...
