import inspect
import torch
from _typeshed import Incomplete
from sympy import Symbol as Symbol
from torch._dynamo.source import AttrSource as AttrSource, GetItemSource as GetItemSource, LocalSource as LocalSource, TensorProperty as TensorProperty, TensorPropertySource as TensorPropertySource
from torch._dynamo.variables.builder import TrackedFake as TrackedFake
from torch._export.passes.add_runtime_assertions_for_constraints_pass import InputDim as InputDim
from torch._export.passes.lift_constants_pass import ConstantAttrMap as ConstantAttrMap
from torch._guards import Source as Source
from torch._library.fake_class_registry import FakeScriptObject as FakeScriptObject
from torch._subclasses.fake_tensor import FakeTensorMode as FakeTensorMode
from torch.export import Constraint as Constraint
from torch.export.graph_signature import CustomObjArgument as CustomObjArgument
from torch.fx.experimental.symbolic_shapes import ConstraintViolationError as ConstraintViolationError, DimDynamic as DimDynamic, EqualityConstraint as EqualityConstraint, GuardOnDataDependentSymNode as GuardOnDataDependentSymNode, RelaxedUnspecConstraint as RelaxedUnspecConstraint, ShapeEnv as ShapeEnv, StatelessSymbolicContext as StatelessSymbolicContext, ValueRanges as ValueRanges
from torch.utils._pytree import GetAttrKey as GetAttrKey, KeyPath as KeyPath, MappingKey as MappingKey, SequenceKey as SequenceKey, tree_map_with_path as tree_map_with_path
from typing import Any

log: Incomplete

def key_path_to_source(kp: KeyPath) -> Source: ...
def fakify(mode: FakeTensorMode, kp: KeyPath, t: Any, t_constraints: dict[int, dict[int, Constraint]], sources: dict[tuple[int, int], list[Source]]): ...
def make_fake_inputs(nn_module, args, kwargs, dynamic_shapes, _is_torch_jit_trace: bool = False, allow_complex_guards_as_runtime_asserts: bool = False): ...
def produce_guards_and_solve_constraints(fake_mode: FakeTensorMode, gm: torch.fx.GraphModule, dynamic_shapes: dict[str, Any] | tuple[Any] | list[Any] | None, equalities_inputs: EqualityConstraint, original_signature: inspect.Signature, _is_torch_jit_trace: bool = False): ...
def make_constraints(fake_mode: FakeTensorMode, gm: torch.fx.GraphModule, combined_args: dict[str, Any], dynamic_shapes: dict[str, Any] | tuple[Any] | list[Any] | None, num_lifted_inputs: int): ...

class _NonStrictTorchFunctionHandler(torch.overrides.TorchFunctionMode):
    def __torch_function__(self, func, types, args=(), kwargs: Incomplete | None = None): ...
