import torch
from .apis import vmap as vmap
from .vmap import doesnt_support_saved_tensors_hooks as doesnt_support_saved_tensors_hooks, get_chunk_sizes as get_chunk_sizes
from _typeshed import Incomplete
from collections.abc import Generator
from torch._C._functorch import get_inplace_requires_grad_allowed as get_inplace_requires_grad_allowed, set_inplace_requires_grad_allowed as set_inplace_requires_grad_allowed
from torch._functorch.utils import argnums_t as argnums_t, exposed_in as exposed_in
from torch._subclasses.functional_tensor import FunctionalTensor as FunctionalTensor
from torch.fx.experimental import const_fold as const_fold
from torch.fx.experimental.proxy_tensor import make_fx as make_fx
from torch.utils._pytree import tree_flatten as tree_flatten, tree_map as tree_map, tree_map_ as tree_map_, tree_map_only as tree_map_only, tree_unflatten as tree_unflatten, treespec_pprint as treespec_pprint
from typing import Any, Callable

def lazy_dynamo_disallow(func): ...
def enable_inplace_requires_grad(enabled) -> Generator[None]: ...
def vjp(func: Callable, *primals, has_aux: bool = False): ...
def grad_increment_nesting() -> Generator[Incomplete]: ...
def enter_jvp_nesting(): ...
def exit_jvp_nesting() -> None: ...
def jvp_increment_nesting() -> Generator[Incomplete]: ...
def error_if_complex(func_name, args, is_input) -> None: ...
def jacrev(func: Callable, argnums: int | tuple[int] = 0, *, has_aux: bool = False, chunk_size: int | None = None, _preallocate_and_copy: bool = False): ...

JVP_NESTING: int

def assert_flat_tuple_of_tensors(elts: Any, api: str, argname: str) -> None: ...
def assert_non_empty_tensor_output(output: list[Any], api: str) -> None: ...
def assert_output_is_tensor_or_tensors(output: Any, api: str) -> None: ...
def assert_non_empty_list_of_tensors(output: list[torch.Tensor], api: str, argname: str) -> None: ...

jvp_str: str

def safe_unpack_dual(dual, strict): ...
def jvp(func: Callable, primals: Any, tangents: Any, *, strict: bool = False, has_aux: bool = False): ...
def safe_unflatten(tensor, dim, shape): ...
def jacfwd(func: Callable, argnums: argnums_t = 0, has_aux: bool = False, *, randomness: str = 'error'): ...
def hessian(func, argnums: int = 0): ...
def grad_and_value_impl(func, argnums, has_aux, args, kwargs) -> Callable: ...
def grad_impl(func: Callable, argnums: argnums_t, has_aux: bool, args, kwargs): ...
def functionalize(func: Callable, *, remove: str = 'mutations') -> Callable: ...
def linearize(func: Callable, *primals) -> tuple[Any, Callable]: ...
