import torch
from _typeshed import Incomplete
from torch._C import DispatchKey as DispatchKey
from torch._higher_order_ops.utils import UnsupportedAliasMutationException as UnsupportedAliasMutationException, autograd_not_implemented as autograd_not_implemented, diff_tensor_meta as diff_tensor_meta, reenter_make_fx as reenter_make_fx, validate_subgraph_args_types as validate_subgraph_args_types
from torch._ops import HigherOrderOperator as HigherOrderOperator
from torch._subclasses.fake_tensor import FakeTensorMode as FakeTensorMode
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, track_tensor_tree as track_tensor_tree
from typing import Callable

class WhileLoopOp(HigherOrderOperator):
    def __init__(self) -> None: ...
    def __call__(self, cond_fn: Callable, body_fn: Callable, carried_inputs: tuple[torch.Tensor | int | float | bool], additional_inputs: tuple[torch.Tensor | torch.SymInt | int, ...], /): ...

while_loop_op: Incomplete

def while_loop(cond_fn, body_fn, carried_inputs): ...
def while_loop_dense(cond_fn, body_fn, carried_inputs, additional_inputs): ...
def while_loop_tracing(mode, cond_fn, body_fn, carried_inputs, additional_inputs): ...
def check_outputs_carry_consistency(outs: list[torch.Tensor], carries: list[torch.Tensor]) -> None: ...
def while_loop_fake_tensor_mode(mode, cond_fn, body_fn, carried_inputs, additional_inputs): ...
def while_loop_func(ctx, cond_fn, body_fn, carried_inputs, additional_inputs): ...
