from _typeshed import Incomplete
from concurrent.futures import ThreadPoolExecutor
from torch._dynamo.device_interface import get_registered_device_interfaces as get_registered_device_interfaces
from torch._dynamo.utils import dynamo_timed as dynamo_timed, set_feature_use as set_feature_use
from torch._inductor import config as config
from torch._inductor.codecache import CUDACodeCache as CUDACodeCache, CodeCacheFuture as CodeCacheFuture, CppCodeCache as CppCodeCache, CppPythonBindingsCodeCache as CppPythonBindingsCodeCache, HalideCodeCache as HalideCodeCache, LambdaFuture as LambdaFuture, ROCmCodeCache as ROCmCodeCache, TritonCodeCache as TritonCodeCache, TritonFuture as TritonFuture
from torch._inductor.compile_worker.subproc_pool import SubprocPool as SubprocPool
from torch._inductor.runtime.hints import HalideMeta as HalideMeta
from torch.hub import tqdm as tqdm
from torch.utils._triton import has_triton_package as has_triton_package
from typing import Any, Callable

kernel_code_log: Incomplete
log: Incomplete

def pre_fork_setup() -> None: ...
def caching_device_properties() -> None: ...
def shutdown_compile_workers() -> None: ...
def after_fork() -> None: ...
def get_compile_threads() -> int: ...

class AsyncCompile:
    def __init__(self) -> None: ...
    @staticmethod
    def pool() -> ThreadPoolExecutor: ...
    @staticmethod
    def process_pool() -> SubprocPool: ...
    @classmethod
    def warm_pool(cls) -> None: ...
    @classmethod
    def submit(cls, task: Callable[..., Any]) -> Any: ...
    def triton(self, kernel_name: str, source_code: str, device_str: str = 'cuda'): ...
    def multi_kernel(self, *args, **kwargs) -> Any: ...
    def cpp(self, source_code: str): ...
    def cpp_pybinding(self, argtypes: list[str], source_code: str): ...
    def cuda(self, source_code, dst_file_ext, aot_compile: bool = False): ...
    def rocm(self, source_code, dst_file_ext, aot_compile: bool = False): ...
    def halide(self, meta: HalideMeta, source_code: str): ...
    def wait(self, scope: dict[str, Any]) -> None: ...
