import torch
from . import config as config, ir as ir
from .dependencies import WeakDep as WeakDep
from .scheduler import BaseSchedulerNode as BaseSchedulerNode
from .utils import contains_collective as contains_collective, contains_wait as contains_wait, find_recursive_deps_of_node as find_recursive_deps_of_node, find_recursive_users_of_node as find_recursive_users_of_node, is_collective as is_collective, is_fallback_op as is_fallback_op, is_wait as is_wait
from _typeshed import Incomplete
from torch.multiprocessing.reductions import StorageWeakRef as StorageWeakRef

log: Incomplete
overlap_log: Incomplete

def sink_waits(snodes: list[BaseSchedulerNode]) -> list[BaseSchedulerNode]: ...
def raise_comms(snodes: list[BaseSchedulerNode]) -> list[BaseSchedulerNode]: ...
def reorder_compute_for_overlap(snodes: list[BaseSchedulerNode]) -> list[BaseSchedulerNode]: ...
def decide_global_ordering_of_comms(nodes: list[BaseSchedulerNode], name_to_buf, name_to_fused_node) -> list[BaseSchedulerNode]: ...
def estimate_op_runtime(snode: BaseSchedulerNode) -> float: ...
def node_summary(snode): ...
def visualize_overlap(order) -> None: ...
def reorder_compute_and_comm_for_overlap(snodes: list[BaseSchedulerNode]) -> list[BaseSchedulerNode]: ...
def remove_fsdp2_unsharded_param_graph_input_usage(graph: torch.fx.Graph): ...
def reinplace_fsdp_all_gather(graph: torch.fx.Graph) -> None: ...
def get_op_idx(snode): ...
def enforce_comm_ordering_for_fsdp(snodes: list[torch._inductor.scheduler.BaseSchedulerNode], name_to_buf: dict[str, torch._inductor.scheduler.SchedulerBuffer], name_to_fused_node: dict[str, BaseSchedulerNode]) -> list[torch._inductor.scheduler.BaseSchedulerNode]: ...
