import torch
import torch.fx
from .virtualized import V as V
from _typeshed import Incomplete
from torch._dispatch.python import enable_python_dispatcher as enable_python_dispatcher
from torch.fx.experimental.symbolic_shapes import compute_unbacked_bindings as compute_unbacked_bindings, rebind_unbacked as rebind_unbacked, statically_known_true as statically_known_true, sym_eq as sym_eq
from torch.utils._pytree import tree_map as tree_map
from typing import Any, Callable

def matches_module_function_pattern(pattern: tuple[type[torch.nn.modules.Module], Callable[..., Any]], node: torch.fx.node.Node, modules: dict[str, torch.nn.modules.Module]) -> bool: ...

class FakeTensorUpdater:
    processed_hashes: Incomplete
    graph: Incomplete
    def __init__(self, graph: torch.fx.Graph) -> None: ...
    def hash_node(self, node: torch.fx.Node): ...
    def incremental_update(self): ...

def get_storage(t: torch.Tensor) -> int: ...
def get_node_storage(node: torch.fx.Node) -> int | None: ...
def get_fake(x): ...
def get_fake_args_kwargs(x: torch.fx.Node) -> tuple[bool, tuple[Any], dict[str, Any]]: ...
def is_node_realized(node: torch.fx.Node) -> bool: ...
