import dataclasses
from .runtime.benchmarking import benchmarker as benchmarker
from .runtime.runtime_utils import create_bandwidth_info_str as create_bandwidth_info_str, get_num_bytes as get_num_bytes
from torch.autograd import DeviceType as DeviceType

def get_kernel_category_by_source_code(src_code): ...
def get_kernel_category(kernel_mod): ...
def get_triton_kernel(mod): ...
def benchmark_all_kernels(benchmark_name, benchmark_all_configs): ...

@dataclasses.dataclass
class ProfileEvent:
    category: str
    key: str
    self_device_time_ms: float
    count: float

def parse_profile_event_list(benchmark_name, event_list, wall_time_ms, nruns, device_name): ...
def perf_profile(wall_time_ms, times, repeat, benchmark_name, benchmark_compiled_module_fn) -> None: ...
def ncu_analyzer(benchmark_name, benchmark_compiled_module_fn) -> None: ...
def collect_memory_snapshot(benchmark_compiled_module_fn) -> None: ...
def compiled_module_main(benchmark_name, benchmark_compiled_module_fn) -> None: ...
