import torch
from _typeshed import Incomplete
from torch._library.utils import parse_namespace as parse_namespace
from typing import Any, Protocol

log: Incomplete

class FakeScriptObject:
    wrapped_obj: Incomplete
    script_class_name: Incomplete
    real_obj: Incomplete
    def __init__(self, wrapped_obj: Any, script_class_name: str, x: torch.ScriptObject) -> None: ...

class FakeScriptMethod:
    self_fake_obj: Incomplete
    method_name: Incomplete
    schema: Incomplete
    def __init__(self, self_fake_obj: FakeScriptObject, method_name: str, schema: torch.FunctionSchema | None) -> None: ...
    def __call__(self, *args, **kwargs): ...

class HasStaticMethodFromReal(Protocol):
    @classmethod
    def from_real(cls, real_obj: torch.ScriptObject): ...

class FakeClassRegistry:
    def __init__(self) -> None: ...
    def has_impl(self, full_qualname: str) -> bool: ...
    def get_impl(self, full_qualname: str) -> Any: ...
    def register(self, full_qualname: str, fake_class: Incomplete | None = None) -> None: ...
    def deregister(self, full_qualname: str) -> Any: ...
    def clear(self) -> None: ...

global_fake_class_registry: Incomplete

def tracing_with_real(x: torch.ScriptObject) -> bool: ...
def maybe_to_fake_obj(fake_mode, x: torch.ScriptObject) -> FakeScriptObject | torch.ScriptObject: ...
def register_fake_class(qualname, fake_class: HasStaticMethodFromReal | None = None): ...
def deregister_fake_class(qualname): ...
def has_fake_class(full_qualname) -> bool: ...
def find_fake_class(full_qualname) -> Any | None: ...
