import torch
from _typeshed import Incomplete
from collections.abc import Generator
from torch._library.utils import Kernel as Kernel, RegistrationHandle as RegistrationHandle
from typing import Callable

class FakeImplHolder:
    qualname: str
    kernel: Kernel | None
    lib: torch.library.Library | None
    def __init__(self, qualname: str) -> None: ...
    def register(self, func: Callable, source: str) -> RegistrationHandle: ...

def construct_meta_kernel(qualname: str, fake_impl_holder: FakeImplHolder) -> Callable: ...
def get_none() -> None: ...

global_ctx_getter: Callable

def set_ctx_getter(ctx_getter) -> Generator[None]: ...

class FakeImplCtx:
    def __init__(self, _fake_mode, _op) -> None: ...
    def create_unbacked_symint(self, *, min: int = 2, max: Incomplete | None = None) -> torch.SymInt: ...
    def new_dynamic_size(self, *, min: int = 0, max: Incomplete | None = None) -> torch.SymInt: ...

def allocate_size(shape_env, min_val: int = 0, max_val: Incomplete | None = None): ...
