from _typeshed import Incomplete

__all__ = ['dtype', 'DType', 'typecodes', 'issubdtype', 'set_default_dtype', 'sctypes', 'int8', 'int16', 'int32', 'int64', 'uint8', 'uint16', 'uint32', 'uint64', 'float16', 'float32', 'float64', 'complex64', 'complex128', 'bool_', 'intp', 'int_', 'intc', 'byte', 'short', 'longlong', 'ulonglong', 'ubyte', 'half', 'single', 'double', 'float_', 'csingle', 'singlecomplex', 'cdouble', 'cfloat', 'complex_', 'generic', 'number', 'integer', 'signedinteger', 'unsignedinteger', 'inexact', 'floating', 'complexfloating']

class generic:
    name: str
    def __new__(cls, value): ...

class number(generic):
    name: str

class integer(number):
    name: str

class inexact(number):
    name: str

class signedinteger(integer):
    name: str

class unsignedinteger(integer):
    name: str

class floating(inexact):
    name: str

class complexfloating(inexact):
    name: str

class int8(signedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class int16(signedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class int32(signedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class int64(signedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class uint8(unsignedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class uint16(unsignedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class uint32(signedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class uint64(signedinteger):
    name: str
    typecode: str
    torch_dtype: Incomplete

class float16(floating):
    name: str
    typecode: str
    torch_dtype: Incomplete

class float32(floating):
    name: str
    typecode: str
    torch_dtype: Incomplete

class float64(floating):
    name: str
    typecode: str
    torch_dtype: Incomplete

class complex64(complexfloating):
    name: str
    typecode: str
    torch_dtype: Incomplete

class complex128(complexfloating):
    name: str
    typecode: str
    torch_dtype: Incomplete

class bool_(generic):
    name: str
    typecode: str
    torch_dtype: Incomplete

sctypes: Incomplete

def dtype(arg): ...

class DType:
    def __init__(self, arg) -> None: ...
    @property
    def name(self): ...
    @property
    def type(self): ...
    @property
    def kind(self): ...
    @property
    def typecode(self): ...
    def __eq__(self, other): ...
    @property
    def torch_dtype(self): ...
    def __hash__(self): ...
    @property
    def itemsize(self): ...

typecodes: Incomplete

def set_default_dtype(fp_dtype: str = 'numpy', int_dtype: str = 'numpy'): ...
def issubdtype(arg1, arg2): ...

# Names in __all__ with no definition:
#   byte
#   cdouble
#   cfloat
#   complex_
#   csingle
#   double
#   float_
#   half
#   int_
#   intc
#   intp
#   longlong
#   short
#   single
#   singlecomplex
#   ubyte
#   ulonglong
