from ._normalizations import ArrayLike as ArrayLike, KeepDims as KeepDims, normalizer as normalizer
from _typeshed import Incomplete
from typing import Sequence

class LinAlgError(Exception): ...

def linalg_errors(func): ...
def matrix_power(a: ArrayLike, n): ...
def multi_dot(inputs: Sequence[ArrayLike], *, out: Incomplete | None = None): ...
def solve(a: ArrayLike, b: ArrayLike): ...
def lstsq(a: ArrayLike, b: ArrayLike, rcond: Incomplete | None = None): ...
def inv(a: ArrayLike): ...
def pinv(a: ArrayLike, rcond: float = 1e-15, hermitian: bool = False): ...
def tensorsolve(a: ArrayLike, b: ArrayLike, axes: Incomplete | None = None): ...
def tensorinv(a: ArrayLike, ind: int = 2): ...
def det(a: ArrayLike): ...
def slogdet(a: ArrayLike): ...
def cond(x: ArrayLike, p: Incomplete | None = None): ...
def matrix_rank(a: ArrayLike, tol: Incomplete | None = None, hermitian: bool = False): ...
def norm(x: ArrayLike, ord: Incomplete | None = None, axis: Incomplete | None = None, keepdims: KeepDims = False): ...
def cholesky(a: ArrayLike): ...
def qr(a: ArrayLike, mode: str = 'reduced'): ...
def svd(a: ArrayLike, full_matrices: bool = True, compute_uv: bool = True, hermitian: bool = False): ...
def eig(a: ArrayLike): ...
def eigh(a: ArrayLike, UPLO: str = 'L'): ...
def eigvals(a: ArrayLike): ...
def eigvalsh(a: ArrayLike, UPLO: str = 'L'): ...
