from ._normalizations import ArrayLike
from _typeshed import Incomplete

__all__ = ['seed', 'random_sample', 'sample', 'random', 'rand', 'randn', 'normal', 'choice', 'randint', 'shuffle', 'uniform']

def seed(seed: Incomplete | None = None) -> None: ...
def random_sample(size: Incomplete | None = None): ...
def rand(*size): ...
sample = random_sample
random = random_sample

def uniform(low: float = 0.0, high: float = 1.0, size: Incomplete | None = None): ...
def randn(*size): ...
def normal(loc: float = 0.0, scale: float = 1.0, size: Incomplete | None = None): ...
def shuffle(x) -> None: ...
def randint(low, high: Incomplete | None = None, size: Incomplete | None = None): ...
def choice(a: ArrayLike, size: Incomplete | None = None, replace: bool = True, p: ArrayLike | None = None): ...
