from _typeshed import Incomplete
from torch._prims_common import CustomOutParamAnnotation as CustomOutParamAnnotation, ELEMENTWISE_TYPE_PROMOTION_KIND as ELEMENTWISE_TYPE_PROMOTION_KIND, Number as Number, NumberType as NumberType, ShapeType as ShapeType, TensorLike as TensorLike, TensorLikeType as TensorLikeType
from torch.utils._pytree import tree_flatten as tree_flatten, tree_unflatten as tree_unflatten
from typing import Callable, Sequence

class elementwise_type_promotion_wrapper:
    type_promoting_arg_names: Incomplete
    type_promotion_kind: Incomplete
    def __init__(self, *, type_promotion_kind: ELEMENTWISE_TYPE_PROMOTION_KIND, type_promoting_args: Sequence[str] | None = None) -> None: ...
    def __call__(self, fn: Callable) -> Callable: ...

def is_cpu_scalar(x: TensorLikeType) -> bool: ...
def check_copy_devices(*, copy_from: TensorLikeType, copy_to: TensorLikeType) -> None: ...
def out_wrapper(*out_names: str, exact_dtype: bool = False, pass_is_out: bool = False, preserve_memory_format: bool = False) -> Callable[[Callable[_P, _T]], Callable[_P, _T]]: ...
def backwards_not_supported(prim): ...
def elementwise_unary_scalar_wrapper(fn: Callable) -> Callable: ...
