import ast
from _typeshed import Incomplete
from torch._C import ErrorReport as ErrorReport
from torch._C._jit_tree_views import SourceRangeFactory as SourceRangeFactory
from typing import Any, NamedTuple

def get_source_lines_and_file(obj: Any, error_msg: str | None = None) -> tuple[list[str], int, str | None]: ...
def normalize_source_lines(sourcelines: list[str]) -> list[str]: ...

class SourceContext(SourceRangeFactory):
    uses_true_division: Incomplete
    filename: Incomplete
    funcname: Incomplete
    def __init__(self, source, filename, file_lineno, leading_whitespace_len, uses_true_division: bool = True, funcname: Incomplete | None = None) -> None: ...

def make_source_context(*args): ...
def fake_range(): ...

class ParsedDef(NamedTuple):
    ast: ast.Module
    ctx: SourceContext
    source: str
    filename: str | None
    file_lineno: int

def parse_def(fn): ...
