from _typeshed import Incomplete
from typing import Callable, Generic
from typing_extensions import ParamSpec

def get_tensor_metadata(tensor): ...
def set_tensor_metadata(tensor, metadata) -> None: ...
def annotate(ret, **kwargs): ...
def render_call(fn, args, kwargs): ...

class KeyErrorMessage(str): ...

class ExceptionWrapper:
    exc_type: Incomplete
    exc_msg: Incomplete
    where: Incomplete
    def __init__(self, exc_info: Incomplete | None = None, where: str = 'in background') -> None: ...
    def reraise(self) -> None: ...

def get_current_device_index() -> int: ...

class _ClassPropertyDescriptor:
    fget: Incomplete
    def __init__(self, fget, fset: Incomplete | None = None) -> None: ...
    def __get__(self, instance, owner: Incomplete | None = None): ...

def classproperty(func): ...
def is_compiling() -> bool: ...

class _LazySeedTracker:
    manual_seed_all_cb: Incomplete
    manual_seed_cb: Incomplete
    call_order: Incomplete
    def __init__(self) -> None: ...
    def queue_seed_all(self, cb, traceback) -> None: ...
    def queue_seed(self, cb, traceback) -> None: ...
    def get_calls(self) -> list: ...

logger: Incomplete
P = ParamSpec('P')

class CallbackRegistry(Generic[P]):
    name: Incomplete
    callback_list: list[Callable[P, None]]
    def __init__(self, name: str) -> None: ...
    def add_callback(self, cb: Callable[P, None]) -> None: ...
    def fire_callbacks(self, *args: P.args, **kwargs: P.kwargs) -> None: ...

IMPORT_MAPPING: Incomplete
NAME_MAPPING: Incomplete
