from _typeshed import Incomplete

__all__ = ['vjp', 'jvp', 'jacobian', 'hessian', 'hvp', 'vhp']

def vjp(func, inputs, v: Incomplete | None = None, create_graph: bool = False, strict: bool = False): ...
def jvp(func, inputs, v: Incomplete | None = None, create_graph: bool = False, strict: bool = False): ...
def jacobian(func, inputs, create_graph: bool = False, strict: bool = False, vectorize: bool = False, strategy: str = 'reverse-mode'): ...
def hessian(func, inputs, create_graph: bool = False, strict: bool = False, vectorize: bool = False, outer_jacobian_strategy: str = 'reverse-mode'): ...
def vhp(func, inputs, v: Incomplete | None = None, create_graph: bool = False, strict: bool = False): ...
def hvp(func, inputs, v: Incomplete | None = None, create_graph: bool = False, strict: bool = False): ...
