__all__ = ['enable', 'is_enabled', 'tuning_enable', 'tuning_is_enabled', 'record_untuned_enable', 'record_untuned_is_enabled', 'set_max_tuning_duration', 'get_max_tuning_duration', 'set_max_tuning_iterations', 'get_max_tuning_iterations', 'set_filename', 'get_filename', 'get_results', 'get_validators', 'write_file_on_exit', 'write_file', 'read_file', 'tune_gemm_in_file', 'mgpu_tune_gemm_in_file']

def enable(val: bool = True) -> None: ...
def is_enabled() -> bool: ...
def tuning_enable(val: bool = True) -> None: ...
def tuning_is_enabled() -> bool: ...
def record_untuned_enable(val: bool = True) -> None: ...
def record_untuned_is_enabled() -> bool: ...
def set_max_tuning_duration(duration: int) -> None: ...
def get_max_tuning_duration() -> int: ...
def set_max_tuning_iterations(iterations: int) -> None: ...
def get_max_tuning_iterations() -> int: ...
def set_filename(filename: str, insert_device_ordinal: bool = False) -> None: ...
def get_filename() -> str: ...
def get_results() -> tuple[str, str, str, float]: ...
def get_validators() -> tuple[str, str]: ...
def write_file_on_exit(val: bool) -> None: ...
def write_file(filename: str | None = None) -> bool: ...
def read_file(filename: str | None = None) -> bool: ...
def tune_gemm_in_file(filename: str) -> None: ...
def mgpu_tune_gemm_in_file(filename_pattern: str, num_gpus: int) -> None: ...
