import torch
from torch import nn as nn
from torch.nn.utils.rnn import PackedSequence as PackedSequence
from typing import Any, OrderedDict, TypeVar

S = TypeVar('S', dict, list, tuple)
T = TypeVar('T', torch.Tensor, PackedSequence)
Q = TypeVar('Q')
R = TypeVar('R', dict, list, tuple, set, OrderedDict, PackedSequence, Any)
