import torch
from _typeshed import Incomplete
from torch.distributions.distribution import Distribution
from torch.types import _size

__all__ = ['OneHotCategorical', 'OneHotCategoricalStraightThrough']

class OneHotCategorical(Distribution):
    arg_constraints: Incomplete
    support: Incomplete
    has_enumerate_support: bool
    def __init__(self, probs: Incomplete | None = None, logits: Incomplete | None = None, validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    @property
    def probs(self): ...
    @property
    def logits(self): ...
    @property
    def mean(self): ...
    @property
    def mode(self): ...
    @property
    def variance(self): ...
    @property
    def param_shape(self): ...
    def sample(self, sample_shape=...): ...
    def log_prob(self, value): ...
    def entropy(self): ...
    def enumerate_support(self, expand: bool = True): ...

class OneHotCategoricalStraightThrough(OneHotCategorical):
    has_rsample: bool
    def rsample(self, sample_shape: _size = ...) -> torch.Tensor: ...
