import torch
from _typeshed import Incomplete
from torch.distributions.distribution import Distribution
from torch.distributions.transformed_distribution import TransformedDistribution
from torch.types import _size

__all__ = ['LogitRelaxedBernoulli', 'RelaxedBernoulli']

class LogitRelaxedBernoulli(Distribution):
    arg_constraints: Incomplete
    support: Incomplete
    temperature: Incomplete
    def __init__(self, temperature, probs: Incomplete | None = None, logits: Incomplete | None = None, validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    def logits(self): ...
    def probs(self): ...
    @property
    def param_shape(self): ...
    def rsample(self, sample_shape: _size = ...) -> torch.Tensor: ...
    def log_prob(self, value): ...

class RelaxedBernoulli(TransformedDistribution):
    arg_constraints: Incomplete
    support: Incomplete
    has_rsample: bool
    def __init__(self, temperature, probs: Incomplete | None = None, logits: Incomplete | None = None, validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    @property
    def temperature(self): ...
    @property
    def logits(self): ...
    @property
    def probs(self): ...
