import torch
from _typeshed import Incomplete
from torch.distributions import constraints
from torch.distributions.distribution import Distribution
from torch.types import _size

__all__ = ['TransformedDistribution']

class TransformedDistribution(Distribution):
    arg_constraints: dict[str, constraints.Constraint]
    transforms: Incomplete
    base_dist: Incomplete
    def __init__(self, base_distribution, transforms, validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    def support(self): ...
    @property
    def has_rsample(self): ...
    def sample(self, sample_shape=...): ...
    def rsample(self, sample_shape: _size = ...) -> torch.Tensor: ...
    def log_prob(self, value): ...
    def cdf(self, value): ...
    def icdf(self, value): ...
