from ._compatibility import compatibility as compatibility
from _typeshed import Incomplete
from torch.fx.graph_module import GraphModule as GraphModule, reduce_graph_module as reduce_graph_module, reduce_package_graph_module as reduce_package_graph_module
from torch.package import PackageExporter as PackageExporter, sys_importer as sys_importer

class _LazyGraphModule(GraphModule):
    @classmethod
    def from_graphmodule(cls, gm: GraphModule): ...
    @staticmethod
    def force_recompile(gm) -> None: ...
    def real_recompile(self) -> None: ...
    forward: Incomplete
    def __reduce_package__(self, exporter: PackageExporter): ...
    def __reduce__(self): ...
    @classmethod
    def recompile(cls) -> None: ...
    @property
    def code(self) -> str: ...
