from _typeshed import Incomplete
from torch._jit_internal import Future as Future, export as export, ignore as ignore, unused as unused
from torch.jit._async import fork as fork, wait as wait
from torch.jit._freeze import freeze as freeze, optimize_for_inference as optimize_for_inference
from torch.jit._fuser import set_fusion_strategy as set_fusion_strategy
from torch.jit._script import Attribute as Attribute, CompilationUnit as CompilationUnit, ScriptFunction as ScriptFunction, ScriptModule as ScriptModule, interface as interface, script as script
from torch.jit._serialization import load as load, save as save
from torch.jit._trace import trace as trace, trace_module as trace_module
from typing import Any

__all__ = ['Attribute', 'CompilationUnit', 'Error', 'Future', 'ScriptFunction', 'ScriptModule', 'annotate', 'enable_onednn_fusion', 'export', 'export_opnames', 'fork', 'freeze', 'interface', 'ignore', 'isinstance', 'load', 'onednn_fusion_enabled', 'optimize_for_inference', 'save', 'script', 'script_if_tracing', 'set_fusion_strategy', 'strict_fusion', 'trace', 'trace_module', 'unused', 'wait']

def export_opnames(m): ...

Error: Incomplete

def annotate(the_type, the_value): ...
def script_if_tracing(fn): ...
def isinstance(obj, target_type): ...

class strict_fusion:
    def __init__(self) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, type: Any, value: Any, tb: Any) -> None: ...

def enable_onednn_fusion(enabled: bool): ...
def onednn_fusion_enabled(): ...
