import torch
from . import profiler as profiler
from .event import Event as Event
from torch import Tensor

__all__ = ['device_count', 'get_rng_state', 'manual_seed', 'seed', 'set_rng_state', 'synchronize', 'empty_cache', 'set_per_process_memory_fraction', 'current_allocated_memory', 'driver_allocated_memory', 'Event', 'profiler', 'recommended_max_memory', 'is_available']

def device_count() -> int: ...
def synchronize() -> None: ...
def get_rng_state(device: int | str | torch.device = 'mps') -> Tensor: ...
def set_rng_state(new_state: Tensor, device: int | str | torch.device = 'mps') -> None: ...
def manual_seed(seed: int) -> None: ...
def seed() -> None: ...
def empty_cache() -> None: ...
def set_per_process_memory_fraction(fraction) -> None: ...
def current_allocated_memory() -> int: ...
def driver_allocated_memory() -> int: ...
def recommended_max_memory() -> int: ...
def is_available() -> bool: ...
