from _typeshed import Incomplete
from torch._namedtensor_internals import check_serializing_named_tensor as check_serializing_named_tensor

class StorageWeakRef:
    cdata: Incomplete
    def __init__(self, storage) -> None: ...
    @classmethod
    def from_weakref(cls, cdata): ...
    def expired(self): ...
    def __del__(self) -> None: ...
    def __hash__(self): ...
    def __eq__(self, other): ...

class SharedCache(dict):
    limit: int
    def __init__(self) -> None: ...
    def get(self, key): ...
    def __setitem__(self, key, storage_ref) -> None: ...
    def free_dead_references(self) -> None: ...

shared_cache: Incomplete

def rebuild_event(device, handle): ...
def reduce_event(event): ...
def rebuild_tensor(cls, storage, metadata): ...
def rebuild_meta_tensor(tensor_cls, tensor_size, tensor_stride, tensor_offset, dtype, storage_size_bytes, requires_grad): ...
def rebuild_cuda_tensor(tensor_cls, tensor_size, tensor_stride, tensor_offset, storage_cls, dtype, storage_device, storage_handle, storage_size_bytes, storage_offset_bytes, requires_grad, ref_counter_handle, ref_counter_offset, event_handle, event_sync_required): ...
def reduce_tensor(tensor): ...
def rebuild_nested_tensor(rebuild_buffer_func, rebuild_buffer_args, rebuild_sizes_func, rebuild_sizes_args, rebuild_strides_func, rebuild_strides_args, rebuild_offsets_func, rebuild_offsets_args): ...
def reduce_nested_tensor(nt): ...
def rebuild_sparse_coo_tensor(rebuild_indices_func, rebuild_indices_args, rebuild_values_func, rebuild_values_args, shape, is_coalesced): ...
def rebuild_sparse_compressed_tensor(rebuild_compressed_indices_func, rebuild_compressed_indices_args, rebuild_plain_indices_func, rebuild_plain_indices_args, rebuild_values_func, rebuild_values_args, shape, layout): ...
def reduce_sparse_tensor(sparse): ...
def fd_id(fd): ...
def storage_from_cache(cls, key): ...
def rebuild_storage_fd(cls, df, size): ...
def rebuild_storage_filename(cls, manager, handle, size, dtype: Incomplete | None = None): ...
def rebuild_storage_empty(cls): ...
def rebuild_typed_storage(storage, dtype): ...
def reduce_typed_storage(storage): ...
def rebuild_typed_storage_child(storage, storage_type): ...
def reduce_typed_storage_child(storage): ...
def reduce_storage(storage): ...
def init_reductions() -> None: ...
