import dataclasses
import dis
from _typeshed import Incomplete
from typing import Any

TERMINAL_OPCODES: Incomplete
JUMP_OPCODES: Incomplete
JUMP_OPNAMES: Incomplete
HASLOCAL: Incomplete
HASFREE: Incomplete
stack_effect = dis.stack_effect

def get_indexof(insts): ...
def remove_dead_code(instructions): ...
def remove_pointless_jumps(instructions): ...
def propagate_line_nums(instructions) -> None: ...
def remove_extra_line_nums(instructions) -> None: ...

@dataclasses.dataclass
class ReadsWrites:
    reads: set[Any]
    writes: set[Any]
    visited: set[Any]

def livevars_analysis(instructions, instruction): ...

@dataclasses.dataclass
class FixedPointBox:
    value: bool = ...

@dataclasses.dataclass
class StackSize:
    low: int | float
    high: int | float
    fixed_point: FixedPointBox
    def zero(self) -> None: ...
    def offset_of(self, other, n) -> None: ...
    def exn_tab_jump(self, depth) -> None: ...

def stacksize_analysis(instructions) -> int | float: ...
