from . import config as config
from .types import DynamoFrameType as DynamoFrameType
from _typeshed import Incomplete
from dataclasses import dataclass
from torch._guards import CompileId as CompileId

log: Incomplete

@dataclass
class CacheSizeRelevantForFrame:
    num_cache_entries: int = ...
    num_cache_entries_with_same_id_matched_objs: int = ...
    def will_compilation_exceed(self, limit: int) -> bool: ...
    def will_compilation_exceed_accumulated_limit(self) -> bool: ...
    def will_compilation_exceed_specific_limit(self, limit: int) -> bool: ...

def compute_cache_size(frame: DynamoFrameType, cache_entry) -> CacheSizeRelevantForFrame: ...
def is_recompilation(cache_size: CacheSizeRelevantForFrame) -> bool: ...
def exceeds_cache_size_limit(cache_size: CacheSizeRelevantForFrame, compile_id: CompileId) -> tuple[bool, str]: ...
