import torch
from _typeshed import Incomplete
from typing import Any, Callable

def is_compiling() -> bool: ...
def wrap_inline(fn: Callable[..., Any]) -> Callable[..., Any]: ...
def call_hook(hook: Callable[..., torch.Tensor | None], *args: Any, **kwargs: Any) -> torch.Tensor: ...
def wrap_numpy(f: Callable[..., Any]) -> Callable[..., Any]: ...

class FakeBackwardCFunction:
    real: Incomplete
    saved_tensors: Incomplete
    def __init__(self, real: torch.autograd.function.BackwardCFunction, saved_tensors: list[torch.Tensor]) -> None: ...
    def __getattr__(self, name: str) -> Any: ...

def call_backward(backward_c_function: torch.autograd.function.BackwardCFunction, saved_tensors: list[torch.Tensor], *args: Any) -> torch.Tensor | tuple[torch.Tensor, ...]: ...
def untyped_storage_size(x: torch.Tensor) -> int: ...

class FakeCompiledAutogradEngine:
    @staticmethod
    def queue_callback(final_callbacks: list[Callable[[], None]], cb: Callable[[], None]) -> None: ...
    @staticmethod
    def exec_final_callbacks(final_callbacks: list[Callable[[], None]]) -> None: ...

def call_hook_from_backward_state(*args: Any, bw_state: Any, hook_name: str, **kwargs: Any) -> Any: ...
def call_module_hooks_from_backward_state(_: Any, result: Any, *args: Any, bw_state: Any, hooks_name: str, module_name: str) -> Any: ...
