import torch
from _typeshed import Incomplete
from torch._export.passes.lift_constants_pass import ConstantAttrMap as ConstantAttrMap
from torch._guards import detect_fake_mode as detect_fake_mode
from torch._ops import OperatorBase as OperatorBase
from torch._subclasses.fake_tensor import FakeTensor as FakeTensor
from torch._subclasses.functional_tensor import FunctionalTensor as FunctionalTensor
from torch.export import ExportedProgram as ExportedProgram
from torch.export.graph_signature import CustomObjArgument as CustomObjArgument, ExportGraphSignature as ExportGraphSignature, InputKind as InputKind, OutputKind as OutputKind
from torch.fx._utils import first_call_function_nn_module_stack as first_call_function_nn_module_stack
from torch.fx.passes.runtime_assert import insert_deferred_runtime_asserts as insert_deferred_runtime_asserts
from torch.utils._pytree import Context as Context, FlattenFunc as FlattenFunc, FromDumpableContextFn as FromDumpableContextFn, GetAttrKey as GetAttrKey, KeyPath as KeyPath, MappingKey as MappingKey, SequenceKey as SequenceKey, ToDumpableContextFn as ToDumpableContextFn, UnflattenFunc as UnflattenFunc, keystr as keystr, tree_flatten_with_path as tree_flatten_with_path
from typing import Any, Callable

placeholder_prefixes: Incomplete

def register_dataclass_as_pytree_node(cls, flatten_fn: FlattenFunc | None = None, unflatten_fn: UnflattenFunc | None = None, *, serialized_type_name: str | None = None, to_dumpable_context: ToDumpableContextFn | None = None, from_dumpable_context: FromDumpableContextFn | None = None, return_none_fields: bool = False) -> None: ...
def is_param(program: ExportedProgram, node: torch.fx.Node) -> bool: ...
def get_param(program: ExportedProgram, node: torch.fx.Node) -> torch.nn.Parameter | None: ...
def is_buffer(program: ExportedProgram, node: torch.fx.Node) -> bool: ...
def get_buffer(program: ExportedProgram, node: torch.fx.Node) -> torch.Tensor | None: ...
def is_lifted_tensor_constant(program: ExportedProgram, node: torch.fx.Node) -> bool: ...
def get_lifted_tensor_constant(program: ExportedProgram, node: torch.fx.Node) -> torch.Tensor | None: ...
def sequential_split(gm: torch.fx.GraphModule, node_call_back: Callable[[torch.fx.Node], torch.fx.Node | bool]) -> torch.fx.GraphModule: ...
def nodes_filter(nodes: list[torch.fx.Node], node_call_back) -> list[torch.fx.Node]: ...
def apply_runtime_assertion_pass(gm: torch.fx.GraphModule, graph_signature): ...
def nodes_first(nodes: list[torch.fx.Node], node_call_back: Incomplete | None = None) -> torch.fx.Node | None: ...
def nodes_count(nodes: list[torch.fx.Node], node_call_back) -> int: ...
def nodes_map(nodes: list[torch.fx.Node], node_call_back) -> list[torch.fx.Node]: ...
def node_replace_(old_node: torch.fx.Node, new_node: torch.fx.Node) -> None: ...
def node_inline_(call_mod_node: torch.fx.Node) -> torch.fx.GraphModule | None: ...
def placeholder_naming_pass(gm: torch.fx.GraphModule, export_graph_signature: ExportGraphSignature, mod: torch.nn.Module, fake_args, fake_kwargs, fake_params_buffers, constants: dict[str, Any]) -> None: ...
def remove_proxy_from_state_dict(state_dict: dict, in_place: bool) -> dict: ...
