from _typeshed import Incomplete
from torch._functorch.utils import argnums_t as argnums_t, exposed_in as exposed_in
from torch._functorch.vmap import Callable as Callable, in_dims_t as in_dims_t, out_dims_t as out_dims_t, vmap_impl as vmap_impl

def vmap(func: Callable, in_dims: in_dims_t = 0, out_dims: out_dims_t = 0, randomness: str = 'error', *, chunk_size: Incomplete | None = None) -> Callable: ...
def chunk_vmap(func: Callable, in_dims: in_dims_t = 0, out_dims: out_dims_t = 0, randomness: str = 'error', chunks: int = 2) -> Callable: ...
def grad(func: Callable, argnums: argnums_t = 0, has_aux: bool = False) -> Callable: ...
def grad_and_value(func: Callable, argnums: argnums_t = 0, has_aux: bool = False) -> Callable: ...
