import torch.fx as fx
import torch.nn as nn
from .aot_autograd import aot_function as aot_function, aot_module as aot_module, make_boxed_compiler as make_boxed_compiler
from .compile_utils import strip_overloads as strip_overloads
from .partitioners import default_partition as default_partition, draw_graph as draw_graph, min_cut_rematerialization_partition as min_cut_rematerialization_partition
from _typeshed import Incomplete
from torch import SymInt as SymInt
from torch._decomp import get_decompositions as get_decompositions
from torch.fx.experimental.symbolic_shapes import bind_symbols as bind_symbols
from typing import Callable

log: Incomplete

def ts_compile(fx_g: fx.GraphModule, inps) -> Callable: ...
def draw_graph_compile(name): ...
def nop(fx_g: fx.GraphModule, _) -> Callable: ...

class DebugInterpreter(fx.Interpreter):
    symbol_mapping: Incomplete
    def run(self, *args) -> None: ...
    def run_node(self, n): ...

def debug_nop(fx_g: fx.GraphModule, _) -> Callable: ...
def simple_ts_compile(fx_g, _): ...
def nnc_jit(f): ...

aten: Incomplete
default_decompositions: Incomplete

def print_compile(fx_g, _): ...
def memory_efficient_fusion(fn: Callable | nn.Module, **kwargs): ...
def debug_compile(fx_g, inps): ...

graph_index: int

def get_inputs(input_data_path): ...
def graph_dumper_aot(current_name, folder_name, dump_example_input: bool = False): ...
