import torch
import torch.nn as nn
from torch import Tensor as Tensor
from torch._functorch.utils import exposed_in as exposed_in
from typing import Any, Sequence

def functional_call(module: torch.nn.Module, parameter_and_buffer_dicts: dict[str, Tensor] | Sequence[dict[str, Tensor]], args: Any | tuple | None = None, kwargs: dict[str, Any] | None = None, *, tie_weights: bool = True, strict: bool = False): ...
def stack_module_state(models: Sequence[nn.Module] | nn.ModuleList) -> tuple[dict[str, Any], dict[str, Any]]: ...
def construct_stacked_leaf(tensors: tuple[Tensor, ...] | list[Tensor], name: str) -> Tensor: ...
