from _typeshed import Incomplete
from collections.abc import Generator
from torch import Tensor as Tensor
from torch._C._functorch import is_batchedtensor as is_batchedtensor
from torch.utils._pytree import TreeSpec as TreeSpec, tree_flatten as tree_flatten, tree_map_ as tree_map_, tree_unflatten as tree_unflatten

in_dims_t = int | tuple
out_dims_t = int | tuple[int, ...]

def doesnt_support_saved_tensors_hooks(f): ...

DECOMPOSITIONS_LOADED: bool
DECOMPOSITIONS_LOCK: Incomplete
VMAP_DECOMPOSITIONS_LIB: Incomplete

def lazy_load_decompositions() -> None: ...
def vmap_impl(func, in_dims, out_dims, randomness, chunk_size, *args, **kwargs): ...
def get_chunk_sizes(total_elems, chunk_size): ...
def vmap_increment_nesting(batch_size, randomness) -> Generator[Incomplete]: ...
def restore_vmap(func, in_dims, batch_size, randomness): ...
def wrap_batched(args, bdims, level): ...
def unwrap_batched(args, level): ...
