import torch
from .utils import create_fw_bw_graph as create_fw_bw_graph
from _typeshed import Incomplete
from torch._C import DispatchKey as DispatchKey
from torch._C._functorch import get_unwrapped as get_unwrapped, is_batchedtensor as is_batchedtensor, maybe_get_bdim as maybe_get_bdim
from torch._dispatch.python import suspend_functionalization as suspend_functionalization
from torch._functorch.utils import exposed_in as exposed_in
from torch._guards import detect_fake_mode as detect_fake_mode
from torch._higher_order_ops.utils import UnsupportedAliasMutationException as UnsupportedAliasMutationException, reenter_make_fx as reenter_make_fx, save_tensors_and_symints_for_backward as save_tensors_and_symints_for_backward, saved_tensors_and_symints as saved_tensors_and_symints, unique_graph_id as unique_graph_id, validate_subgraph_args_types as validate_subgraph_args_types
from torch._ops import HigherOrderOperator as HigherOrderOperator
from torch._subclasses.fake_tensor import FakeTensorMode as FakeTensorMode
from torch._subclasses.functional_tensor import disable_functional_mode as disable_functional_mode
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, disable_proxy_modes_tracing as disable_proxy_modes_tracing, track_tensor_tree as track_tensor_tree
from typing import Any, Callable

log: Incomplete

class CondOp(HigherOrderOperator):
    def __init__(self) -> None: ...
    def __call__(self, pred, true_fn, false_fn, operands): ...

cond_op: Incomplete

def cond(pred: bool | int | float | torch.Tensor, true_fn: Callable, false_fn: Callable, operands: tuple | list = ()) -> Any: ...
def create_fw_bw_graph_branches(true_fn, false_fn, *operands): ...
def trace_cond(proxy_mode, func_overload, pred, true_fn, false_fn, operands): ...
def cond_op_dense(pred, true_fn, false_fn, operands): ...

class CondAutogradOp(torch.autograd.Function):
    @staticmethod
    def forward(ctx, pred, fw_true_graph, fw_false_graph, joint_true_graph, joint_false_graph, *operands): ...
    @staticmethod
    def backward(ctx, *flat_grads): ...

def cond_autograd(pred, true_fn, false_fn, operands): ...
def inner(mode, pred, true_fn, false_fn, operands): ...
def cond_fake_tensor_mode(mode, pred, true_fn, false_fn, operands): ...
def cond_func(ctx, pred, true_fn, false_fn, inputs): ...
def cond_batch_rule(interpreter, pred, true_fn, false_fn, inputs): ...
