import torch
from _typeshed import Incomplete
from torch._C import DispatchKey as DispatchKey
from torch._dispatch.python import suspend_functionalization as suspend_functionalization
from torch._higher_order_ops.utils import clone_outputs_aliasing_inputs as clone_outputs_aliasing_inputs, get_dummy_aot_autograd_config as get_dummy_aot_autograd_config, prepare_fw_with_masks as prepare_fw_with_masks, reenter_make_fx as reenter_make_fx, save_tensors_and_symints_for_backward as save_tensors_and_symints_for_backward, saved_tensors_and_symints as saved_tensors_and_symints
from torch._ops import HigherOrderOperator as HigherOrderOperator
from torch._subclasses import FakeTensorMode as FakeTensorMode
from torch._subclasses.functional_tensor import disable_functional_mode as disable_functional_mode
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, disable_proxy_modes_tracing as disable_proxy_modes_tracing, track_tensor_tree as track_tensor_tree
from torch.fx.graph_module import GraphModule as GraphModule

invoke_subgraph_counter: int

class InvokeSubgraphHOP(HigherOrderOperator):
    def __init__(self) -> None: ...
    def __call__(self, subgraph: GraphModule, identifier: str | None, operands: list[torch.Tensor | int | torch.SymInt] | tuple[torch.Tensor | int | torch.SymInt]): ...

invoke_subgraph: Incomplete

def invoke_subgraph_placeholder(subgraph, *args, **kwargs): ...
def mark_compile_region(fn: Incomplete | None = None): ...
def get_invoke_subgraph_cache(): ...
def trace_joint_graph(fn, fw_inputs, fw_outputs): ...
def create_fw_bw_graph(subgraph, operands, grad_outputs: Incomplete | None = None): ...

class InvokeSubgraphAutogradOp(torch.autograd.Function):
    @staticmethod
    def forward(ctx, fw_graph, bw_graph, identifier, num_fw_outs, *operands): ...
    @staticmethod
    def backward(ctx, *grad_outs): ...

def _(subgraph, identifier, operands): ...
