import torch
from .utils import clone_outputs_aliasing_inputs as clone_outputs_aliasing_inputs, prepare_fw_with_masks as prepare_fw_with_masks, save_tensors_and_symints_for_backward as save_tensors_and_symints_for_backward, saved_tensors_and_symints as saved_tensors_and_symints
from _typeshed import Incomplete
from torch._C import DispatchKey as DispatchKey
from torch._dispatch.python import suspend_functionalization as suspend_functionalization
from torch._functorch.aot_autograd import AOTConfig as AOTConfig, create_joint as create_joint
from torch._higher_order_ops.utils import UnsupportedAliasMutationException as UnsupportedAliasMutationException, reenter_make_fx as reenter_make_fx
from torch._ops import HigherOrderOperator as HigherOrderOperator
from torch._subclasses.fake_tensor import FakeTensorMode as FakeTensorMode
from torch._subclasses.functional_tensor import disable_functional_mode as disable_functional_mode
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, disable_proxy_modes_tracing as disable_proxy_modes_tracing, make_fx as make_fx, track_tensor_tree as track_tensor_tree

class MapWrapper(HigherOrderOperator):
    def __init__(self) -> None: ...
    def __call__(self, xs, *args): ...

class MapImpl(HigherOrderOperator):
    def __init__(self) -> None: ...
    def __call__(self, *args, **kwargs): ...

map: Incomplete
map_impl: Incomplete
dummy_aot_config: Incomplete

def create_fw_bw_graph(f, num_mapped_args, *args): ...
def map_wrapper(f, xs, *args): ...

class MapAutogradOp(torch.autograd.Function):
    @staticmethod
    def forward(ctx, fw_graph, joint_graph, num_mapped_args, *flat_args): ...
    @staticmethod
    def backward(ctx, *flat_grads): ...

def trace_map(proxy_mode, func_overload, f, xs, pos_args): ...
def map_dense(f, xs, pos_args): ...
def map_autograd(f, xs, pos_args): ...
def map_proxy_torch_dispatch_mode(mode, f, xs, args): ...
def map_fake_tensor_mode(mode, f, xs, args): ...
def map_functionalize(ctx, f, xs, pos_args): ...
