import abc
import torch
from _typeshed import Incomplete
from torch._C import DispatchKey as DispatchKey
from torch._dispatch.python import suspend_functionalization as suspend_functionalization
from torch._higher_order_ops.utils import reenter_make_fx as reenter_make_fx
from torch._ops import HigherOrderOperator as HigherOrderOperator
from torch._subclasses import FakeTensorMode as FakeTensorMode
from torch._subclasses.functional_tensor import disable_functional_mode as disable_functional_mode
from torch.fx.experimental.proxy_tensor import ProxyTorchDispatchMode as ProxyTorchDispatchMode, disable_proxy_modes_tracing as disable_proxy_modes_tracing, track_tensor_tree as track_tensor_tree

class PrimHOPBase(HigherOrderOperator, abc.ABC):
    def __init__(self, hop_name) -> None: ...
    def __call__(self, subgraph, operands, *unused, **kwargs): ...

class PrimHOPBaseFunction(torch.autograd.Function):
    @staticmethod
    def forward(ctx, hop, subgraph, kwargs, *operands): ...
    @staticmethod
    def backward(ctx, *grad_outputs): ...

class FunctionWithNoFreeVars:
    fn: Incomplete
    def __init__(self, fn) -> None: ...
    def __call__(self, *args, **kwargs): ...
