import torch.fx
from torch._inductor.utils import InputType
from typing import Any

__all__ = ['compile', 'list_mode_options', 'list_options', 'cudagraph_mark_step_begin']

def compile(gm: torch.fx.GraphModule, example_inputs: list[InputType], options: dict[str, Any] | None = None): ...
def list_mode_options(mode: str | None = None, dynamic: bool | None = None) -> dict[str, Any]: ...
def list_options() -> list[str]: ...
def cudagraph_mark_step_begin() -> None: ...
