import torch
from .loop_body import InterpreterShim as InterpreterShim, LoopBody as LoopBody, LoopBodyBlock as LoopBodyBlock
from .utils import cache_on_self as cache_on_self, dominated_nodes as dominated_nodes
from .virtualized import V as V
from _typeshed import Incomplete
from sympy import Expr
from torch.utils._sympy.value_ranges import ValueRangeAnalysis as ValueRangeAnalysis, ValueRanges as ValueRanges, bound_sympy as bound_sympy
from typing import Any, Callable

log: Incomplete

class BoundVars:
    loop_body: Incomplete
    replacement_vals: Incomplete
    unbounded_vars: Incomplete
    def __init__(self, loop_body: LoopBody) -> None: ...
    def get_bounds(self) -> dict[torch.fx.Node, ValueRanges[Expr]]: ...
    def swap_submodules(self, submodules: dict[str, Callable[..., Any]]) -> dict[str, Callable[..., ValueRanges[Expr]]]: ...
    def masked_subblock(self, subblock: LoopBodyBlock, env: dict[torch.fx.Node, ValueRanges[Expr]], mask: Any, value: Any, submodules: dict[str, Callable[..., Any]]) -> ValueRanges[Expr]: ...
    def set_indirect(self, old: Expr, new: ValueRanges[Expr]) -> ValueRanges[Expr]: ...
    def get_index(self, name: str) -> ValueRanges[Expr]: ...
