import torch
from . import config as config
from _typeshed import Incomplete
from torch._dynamo.utils import dynamo_timed as dynamo_timed, lazy_format_graph_code as lazy_format_graph_code
from torch._functorch.aot_autograd import MutationType as MutationType
from torch._functorch.compile_utils import fx_graph_cse as fx_graph_cse
from torch._inductor.constant_folding import constant_fold as constant_fold, replace_node_with_constant as replace_node_with_constant
from torch._inductor.fx_passes.freezing_patterns import freezing_passes as freezing_passes
from torch._inductor.fx_passes.post_grad import view_to_reshape as view_to_reshape
from typing import Any

aten: Incomplete
prims: Incomplete
log: Incomplete

def replace_params_with_constants(gm: torch.fx.GraphModule, flat_params: list[Any], fw_metadata: torch._functorch.aot_autograd.ViewAndMutationMeta) -> list[int]: ...
def freeze(dynamo_gm: torch.fx.GraphModule, aot_autograd_gm: torch.fx.GraphModule, example_inputs: list[torch._subclasses.FakeTensor]) -> tuple[torch.fx.GraphModule, list[int]]: ...

class ErasedTensor(torch.Tensor):
    @staticmethod
    def __new__(cls, elem, name, owning_mod): ...
    erased_name: Incomplete
    owning_mod_ref: Incomplete
    def __init__(self, elem, name: str | None, mod) -> None: ...
    @classmethod
    def __torch_dispatch__(cls, func, types, args=(), kwargs: Incomplete | None = None) -> None: ...

def invalidate_eager_modules() -> None: ...
def discard_traced_gm_params(mod: torch.fx.GraphModule): ...
def enforce_output_layout(gm: torch.fx.GraphModule): ...
def enforce_as_strided_input_layout(gm: torch.fx.GraphModule): ...
def convert_conv_weights_to_channels_last(gm: torch.fx.GraphModule): ...
