from .fake_impl import FakeImplHolder
from .utils import RegistrationHandle
from _typeshed import Incomplete
from typing import Callable

__all__ = ['SimpleLibraryRegistry', 'SimpleOperatorEntry', 'singleton']

class SimpleLibraryRegistry:
    def __init__(self) -> None: ...
    def find(self, qualname: str) -> SimpleOperatorEntry: ...

singleton: SimpleLibraryRegistry

class SimpleOperatorEntry:
    qualname: str
    fake_impl: FakeImplHolder
    torch_dispatch_rules: GenericTorchDispatchRuleHolder
    def __init__(self, qualname: str) -> None: ...
    @property
    def abstract_impl(self): ...

class GenericTorchDispatchRuleHolder:
    qualname: Incomplete
    def __init__(self, qualname) -> None: ...
    def register(self, torch_dispatch_class: type, func: Callable) -> RegistrationHandle: ...
    def find(self, torch_dispatch_class): ...
