from .custom_ops import custom_op as custom_op
from .infer_schema import infer_schema as infer_schema
from _typeshed import Incomplete
from torch.utils._exposed_in import exposed_in as exposed_in
from typing import Any, Callable, Generator, Iterable

def triton_op(name: str, fn: Callable | None = None, /, *, mutates_args: str | Iterable[str], schema: str | None = None) -> Callable: ...

wrap_triton_enabled: Incomplete
wrap_triton_enabled_default: bool

def set_wrap_triton_enabled(enabled: bool) -> Generator[None, None, None]: ...
def is_wrap_triton_enabled() -> bool: ...
def capture_triton(triton_kernel: Callable, /) -> Any: ...
def wrap_triton(triton_kernel: Callable, /) -> Any: ...
