import torch
from ._utils import _device_t
from _typeshed import Incomplete

__all__ = ['current_accelerator', 'current_device_idx', 'current_device_index', 'current_stream', 'device_count', 'is_available', 'set_device_idx', 'set_device_index', 'set_stream', 'synchronize']

def device_count() -> int: ...
def is_available() -> bool: ...
def current_accelerator() -> torch.device: ...
def current_device_index() -> int: ...

current_device_idx: Incomplete

def set_device_index(device: _device_t, /) -> None: ...

set_device_idx: Incomplete

def current_stream(device: _device_t = None, /) -> torch.Stream: ...
def set_stream(stream: torch.Stream) -> None: ...
def synchronize(device: _device_t = None, /) -> None: ...
