from _typeshed import Incomplete
from torch.types import _dtype
from typing import Any

__all__ = ['autocast_decorator', 'autocast', 'is_autocast_available', 'custom_fwd', 'custom_bwd']

def is_autocast_available(device_type: str) -> bool: ...
def autocast_decorator(autocast_instance, func): ...

class autocast:
    device: Incomplete
    fast_dtype: Incomplete
    custom_backend_name: Incomplete
    custom_device_mod: Incomplete
    def __init__(self, device_type: str, dtype: _dtype | None = None, enabled: bool = True, cache_enabled: bool | None = None) -> None: ...
    prev_cache_enabled: Incomplete
    prev: Incomplete
    prev_fastdtype: Incomplete
    def __enter__(self): ...
    def __exit__(self, exc_type: Any, exc_val: Any, exc_tb: Any): ...
    def __call__(self, func): ...

def custom_fwd(fwd: Incomplete | None = None, *, device_type: str, cast_inputs: _dtype | None = None): ...
def custom_bwd(bwd: Incomplete | None = None, *, device_type: str): ...
