from _typeshed import Incomplete
from typing import Callable

__all__ = ['compile', 'assume_constant_result', 'reset', 'allow_in_graph', 'substitute_in_graph', 'list_backends', 'disable', 'set_stance', 'cudagraph_mark_step_begin', 'wrap_numpy', 'is_compiling', 'is_dynamo_compiling']

def compile(*args, **kwargs): ...
def reset() -> None: ...
def allow_in_graph(fn): ...
def substitute_in_graph(original_fn: _F, *, can_constant_fold_through: bool = False, skip_signature_check: bool = False) -> Callable[[_F], _F]: ...
def list_backends(exclude_tags=('debug', 'experimental')) -> list[str]: ...
def assume_constant_result(fn): ...
def disable(fn: Incomplete | None = None, recursive: bool = True): ...
def set_stance(stance: str = 'default', *, skip_guard_eval_unsafe: bool = False, force_backend: Incomplete | None = None): ...
def cudagraph_mark_step_begin() -> None: ...
def wrap_numpy(fn): ...
def is_compiling() -> bool: ...
def is_dynamo_compiling() -> bool: ...
