import torch
from _typeshed import Incomplete

def is_current_stream_capturing(): ...
def graph_pool_handle(): ...

class CUDAGraph(torch._C._CUDAGraph):
    def __new__(cls): ...
    def capture_begin(self, pool: Incomplete | None = None, capture_error_mode: str = 'global') -> None: ...
    def capture_end(self) -> None: ...
    def replay(self) -> None: ...
    def reset(self) -> None: ...
    def pool(self): ...
    def enable_debug_mode(self): ...
    def debug_dump(self, debug_path): ...

class graph:
    default_capture_stream: torch.cuda.Stream | None
    pool: Incomplete
    capture_stream: Incomplete
    stream_ctx: Incomplete
    cuda_graph: Incomplete
    capture_error_mode: Incomplete
    def __init__(self, cuda_graph, pool: Incomplete | None = None, stream: Incomplete | None = None, capture_error_mode: str = 'global') -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_value: BaseException | None, traceback: types.TracebackType | None) -> None: ...

def make_graphed_callables(callables, sample_args, num_warmup_iters: int = 3, allow_unused_input: bool = False, pool: Incomplete | None = None): ...
