import torch
from torch import Tensor
from typing import Iterable

__all__ = ['get_rng_state', 'get_rng_state_all', 'set_rng_state', 'set_rng_state_all', 'manual_seed', 'manual_seed_all', 'seed', 'seed_all', 'initial_seed']

def get_rng_state(device: int | str | torch.device = 'cuda') -> Tensor: ...
def get_rng_state_all() -> list[Tensor]: ...
def set_rng_state(new_state: Tensor, device: int | str | torch.device = 'cuda') -> None: ...
def set_rng_state_all(new_states: Iterable[Tensor]) -> None: ...
def manual_seed(seed: int) -> None: ...
def manual_seed_all(seed: int) -> None: ...
def seed() -> None: ...
def seed_all() -> None: ...
def initial_seed() -> int: ...
