import torch
from typing import Any, Protocol

class _Checkpointable(Protocol):
    def __create_write_items__(self, fqn: str, object: Any): ...
    def __create_chunk_list__(self): ...
    def __get_tensor_shard__(self, index) -> torch.Tensor: ...
