import torch
from _typeshed import Incomplete
from torch.distributions.exp_family import ExponentialFamily
from torch.types import _size

__all__ = ['ContinuousBernoulli']

class ContinuousBernoulli(ExponentialFamily):
    arg_constraints: Incomplete
    support: Incomplete
    has_rsample: bool
    def __init__(self, probs: Incomplete | None = None, logits: Incomplete | None = None, lims=(0.499, 0.501), validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    @property
    def mean(self): ...
    @property
    def stddev(self): ...
    @property
    def variance(self): ...
    def logits(self): ...
    def probs(self): ...
    @property
    def param_shape(self): ...
    def sample(self, sample_shape=...): ...
    def rsample(self, sample_shape: _size = ...) -> torch.Tensor: ...
    def log_prob(self, value): ...
    def cdf(self, value): ...
    def icdf(self, value): ...
    def entropy(self): ...
