from _typeshed import Incomplete
from torch.distributions import constraints
from torch.distributions.distribution import Distribution

__all__ = ['MixtureSameFamily']

class MixtureSameFamily(Distribution):
    arg_constraints: dict[str, constraints.Constraint]
    has_rsample: bool
    def __init__(self, mixture_distribution, component_distribution, validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    def support(self): ...
    @property
    def mixture_distribution(self): ...
    @property
    def component_distribution(self): ...
    @property
    def mean(self): ...
    @property
    def variance(self): ...
    def cdf(self, x): ...
    def log_prob(self, x): ...
    def sample(self, sample_shape=...): ...
