import torch
from _typeshed import Incomplete

__all__ = ['broadcast_all', 'logits_to_probs', 'clamp_probs', 'probs_to_logits', 'lazy_property', 'tril_matrix_to_vec', 'vec_to_tril_matrix']

def broadcast_all(*values): ...
def logits_to_probs(logits, is_binary: bool = False): ...
def clamp_probs(probs): ...
def probs_to_logits(probs, is_binary: bool = False): ...

class lazy_property:
    wrapped: Incomplete
    def __init__(self, wrapped) -> None: ...
    def __get__(self, instance, obj_type: Incomplete | None = None): ...

class _lazy_property_and_property(lazy_property, property):
    def __init__(self, wrapped) -> None: ...

def tril_matrix_to_vec(mat: torch.Tensor, diag: int = 0) -> torch.Tensor: ...
def vec_to_tril_matrix(vec: torch.Tensor, diag: int = 0) -> torch.Tensor: ...
