import torch
from _typeshed import Incomplete
from numbers import Number
from torch.distributions.exp_family import ExponentialFamily
from torch.types import _size

__all__ = ['Wishart']

class Wishart(ExponentialFamily):
    arg_constraints: Incomplete
    support: Incomplete
    has_rsample: bool
    df: Incomplete
    def __init__(self, df: torch.Tensor | Number, covariance_matrix: torch.Tensor | None = None, precision_matrix: torch.Tensor | None = None, scale_tril: torch.Tensor | None = None, validate_args: Incomplete | None = None) -> None: ...
    def expand(self, batch_shape, _instance: Incomplete | None = None): ...
    def scale_tril(self): ...
    def covariance_matrix(self): ...
    def precision_matrix(self): ...
    @property
    def mean(self): ...
    @property
    def mode(self): ...
    @property
    def variance(self): ...
    def rsample(self, sample_shape: _size = ..., max_try_correction: Incomplete | None = None) -> torch.Tensor: ...
    def log_prob(self, value): ...
    def entropy(self): ...
