import torch
from ._tree_utils import reorder_kwargs as reorder_kwargs
from .exported_program import ExportGraphSignature as ExportGraphSignature, ExportedProgram as ExportedProgram, InputKind as InputKind, OutputKind as OutputKind
from _typeshed import Incomplete

class _StatefulGraphModuleFactory(type):
    def __call__(cls, *args, **kwargs) -> None: ...

class _StatefulGraphModule(torch.fx.GraphModule, metaclass=_StatefulGraphModuleFactory):
    range_constraints: Incomplete
    validate_inputs: bool
    def __init__(self, root, graph, range_constraints: Incomplete | None = None) -> None: ...
