import torch
from _typeshed import Incomplete
from typing import Callable

__all__ = ['CustomDecompTable']

class CustomDecompTable(dict[torch._ops.OperatorBase, Callable]):
    decomp_table: Incomplete
    deleted_custom_ops: Incomplete
    has_materialized: bool
    def __init__(self) -> None: ...
    def __getitem__(self, key): ...
    def __setitem__(self, key, value) -> None: ...
    def keys(self): ...
    def __delitem__(self, key) -> None: ...
    def update(self, other_dict) -> None: ...
    def __missing__(self, key) -> bool: ...
    def __contains__(self, key) -> bool: ...
    def __len__(self) -> int: ...
    def __iter__(self): ...
    def __reversed__(self): ...
    def copy(self) -> CustomDecompTable: ...
    def pop(self, *args): ...
    def items(self): ...
    def materialize(self) -> dict[torch._ops.OperatorBase, Callable]: ...
