from torch.utils._pytree import PyTree as PyTree, TreeSpec as TreeSpec
from typing import Any, Callable

FlattenFuncSpec = Callable[[PyTree, TreeSpec], list]
FlattenFuncExactMatchSpec = Callable[[PyTree, TreeSpec], bool]
SUPPORTED_NODES: dict[type[Any], FlattenFuncSpec]
SUPPORTED_NODES_EXACT_MATCH: dict[type[Any], FlattenFuncExactMatchSpec | None]

def register_pytree_flatten_spec(cls, flatten_fn_spec: FlattenFuncSpec, flatten_fn_exact_match_spec: FlattenFuncExactMatchSpec | None = None) -> None: ...
def tree_flatten_spec(pytree: PyTree, spec: TreeSpec, exact_structural_match: bool = False) -> list[Any]: ...
