import os
from _typeshed import Incomplete
from torch.serialization import MAP_LOCATION
from typing import Any

__all__ = ['download_url_to_file', 'get_dir', 'help', 'list', 'load', 'load_state_dict_from_url', 'set_dir']

class _Faketqdm:
    total: Incomplete
    disable: Incomplete
    n: int
    def __init__(self, total: Incomplete | None = None, disable: bool = False, unit: Incomplete | None = None, *args, **kwargs) -> None: ...
    def update(self, n) -> None: ...
    def set_description(self, *args, **kwargs) -> None: ...
    def write(self, s) -> None: ...
    def close(self) -> None: ...
    def __enter__(self): ...
    def __exit__(self, exc_type: type[BaseException] | None, exc_val: BaseException | None, exc_tb: types.TracebackType | None) -> None: ...

def get_dir() -> str: ...
def set_dir(d: str | os.PathLike) -> None: ...
def list(github, force_reload: bool = False, skip_validation: bool = False, trust_repo: Incomplete | None = None, verbose: bool = True): ...
def help(github, model, force_reload: bool = False, skip_validation: bool = False, trust_repo: Incomplete | None = None): ...
def load(repo_or_dir, model, *args, source: str = 'github', trust_repo: Incomplete | None = None, force_reload: bool = False, verbose: bool = True, skip_validation: bool = False, **kwargs): ...
def download_url_to_file(url: str, dst: str, hash_prefix: str | None = None, progress: bool = True) -> None: ...
def load_state_dict_from_url(url: str, model_dir: str | None = None, map_location: MAP_LOCATION = None, progress: bool = True, check_hash: bool = False, file_name: str | None = None, weights_only: bool = False) -> dict[str, Any]: ...
