from _typeshed import Incomplete
from torch import Tensor
from torch.types import _device as Device, _dtype as DType

__all__ = ['to_padded_tensor', 'as_nested_tensor', 'nested_tensor', 'nested_tensor_from_jagged', 'narrow', 'masked_select']

def as_nested_tensor(ts: Tensor | list[Tensor] | tuple[Tensor, ...], dtype: DType | None = None, device: Device | None = None, layout: Incomplete | None = None) -> Tensor: ...

to_padded_tensor: Incomplete

def nested_tensor(tensor_list, *, dtype: Incomplete | None = None, layout: Incomplete | None = None, device: Incomplete | None = None, requires_grad: bool = False, pin_memory: bool = False) -> Tensor: ...
def narrow(tensor: Tensor, dim: int, start: int | Tensor, length: int | Tensor, layout=...) -> Tensor: ...
def nested_tensor_from_jagged(values: Tensor, offsets: Tensor | None = None, lengths: Tensor | None = None, jagged_dim: int | None = None, min_seqlen: int | None = None, max_seqlen: int | None = None) -> Tensor: ...
def masked_select(tensor: Tensor, mask: Tensor) -> Tensor: ...
