from _typeshed import Incomplete
from torch import Tensor as Tensor
from torch._jit_internal import BroadcastingList1 as BroadcastingList1, BroadcastingList2 as BroadcastingList2, BroadcastingList3 as BroadcastingList3, boolean_dispatch as boolean_dispatch
from torch._torch_docs import reproducibility_notes as reproducibility_notes, sparse_support_notes as sparse_support_notes, tf32_notes as tf32_notes
from torch.nn import grad as grad
from torch.overrides import handle_torch_function as handle_torch_function, has_torch_function as has_torch_function, has_torch_function_unary as has_torch_function_unary, has_torch_function_variadic as has_torch_function_variadic
from torch.types import _dtype as DType
from typing import Callable

conv1d: Incomplete
conv2d: Incomplete
conv3d: Incomplete
conv_transpose1d: Incomplete
conv_transpose2d: Incomplete
conv_transpose3d: Incomplete
conv_tbc: Incomplete
avg_pool1d: Incomplete
avg_pool2d: Incomplete
avg_pool3d: Incomplete

def fractional_max_pool2d_with_indices(input: Tensor, kernel_size: BroadcastingList2[int], output_size: BroadcastingList2[int] | None = None, output_ratio: BroadcastingList2[float] | None = None, return_indices: bool = False, _random_samples: Tensor | None = None) -> tuple[Tensor, Tensor]: ...

fractional_max_pool2d: Incomplete

def fractional_max_pool3d_with_indices(input: Tensor, kernel_size: BroadcastingList3[int], output_size: BroadcastingList3[int] | None = None, output_ratio: BroadcastingList3[float] | None = None, return_indices: bool = False, _random_samples: Tensor | None = None) -> tuple[Tensor, Tensor]: ...

fractional_max_pool3d: Incomplete

def max_pool1d_with_indices(input: Tensor, kernel_size: BroadcastingList1[int], stride: BroadcastingList1[int] | None = None, padding: BroadcastingList1[int] = 0, dilation: BroadcastingList1[int] = 1, ceil_mode: bool = False, return_indices: bool = False) -> tuple[Tensor, Tensor]: ...

max_pool1d: Incomplete

def max_pool2d_with_indices(input: Tensor, kernel_size: BroadcastingList2[int], stride: BroadcastingList2[int] | None = None, padding: BroadcastingList2[int] = 0, dilation: BroadcastingList2[int] = 1, ceil_mode: bool = False, return_indices: bool = False) -> tuple[Tensor, Tensor]: ...

max_pool2d: Incomplete

def max_pool3d_with_indices(input: Tensor, kernel_size: BroadcastingList3[int], stride: BroadcastingList3[int] | None = None, padding: BroadcastingList3[int] = 0, dilation: BroadcastingList3[int] = 1, ceil_mode: bool = False, return_indices: bool = False) -> tuple[Tensor, Tensor]: ...

max_pool3d: Incomplete

def max_unpool1d(input: Tensor, indices: Tensor, kernel_size: BroadcastingList1[int], stride: BroadcastingList1[int] | None = None, padding: BroadcastingList1[int] = 0, output_size: BroadcastingList1[int] | None = None) -> Tensor: ...
def max_unpool2d(input: Tensor, indices: Tensor, kernel_size: BroadcastingList2[int], stride: BroadcastingList2[int] | None = None, padding: BroadcastingList2[int] = 0, output_size: BroadcastingList2[int] | None = None) -> Tensor: ...
def max_unpool3d(input: Tensor, indices: Tensor, kernel_size: BroadcastingList3[int], stride: BroadcastingList3[int] | None = None, padding: BroadcastingList3[int] = 0, output_size: BroadcastingList3[int] | None = None) -> Tensor: ...
def lp_pool3d(input: Tensor, norm_type: int | float, kernel_size: BroadcastingList3[int], stride: BroadcastingList3[int] | None = None, ceil_mode: bool = False) -> Tensor: ...
def lp_pool2d(input: Tensor, norm_type: int | float, kernel_size: BroadcastingList2[int], stride: BroadcastingList2[int] | None = None, ceil_mode: bool = False) -> Tensor: ...
def lp_pool1d(input: Tensor, norm_type: int | float, kernel_size: int, stride: BroadcastingList1[int] | None = None, ceil_mode: bool = False) -> Tensor: ...
def adaptive_max_pool1d_with_indices(input: Tensor, output_size: BroadcastingList1[int], return_indices: bool = False) -> tuple[Tensor, Tensor]: ...

adaptive_max_pool1d: Incomplete

def adaptive_max_pool2d_with_indices(input: Tensor, output_size: BroadcastingList2[int], return_indices: bool = False) -> tuple[Tensor, Tensor]: ...

adaptive_max_pool2d: Incomplete

def adaptive_max_pool3d_with_indices(input: Tensor, output_size: BroadcastingList3[int], return_indices: bool = False) -> tuple[Tensor, Tensor]: ...

adaptive_max_pool3d: Incomplete
adaptive_avg_pool1d: Incomplete

def adaptive_avg_pool2d(input: Tensor, output_size: BroadcastingList2[int]) -> Tensor: ...
def adaptive_avg_pool3d(input: Tensor, output_size: BroadcastingList3[int]) -> Tensor: ...
def dropout(input: Tensor, p: float = 0.5, training: bool = True, inplace: bool = False) -> Tensor: ...
def alpha_dropout(input: Tensor, p: float = 0.5, training: bool = False, inplace: bool = False) -> Tensor: ...
def dropout1d(input: Tensor, p: float = 0.5, training: bool = True, inplace: bool = False) -> Tensor: ...
def dropout2d(input: Tensor, p: float = 0.5, training: bool = True, inplace: bool = False) -> Tensor: ...
def dropout3d(input: Tensor, p: float = 0.5, training: bool = True, inplace: bool = False) -> Tensor: ...
def feature_alpha_dropout(input: Tensor, p: float = 0.5, training: bool = False, inplace: bool = False) -> Tensor: ...

threshold: Incomplete
threshold_: Incomplete

def relu(input: Tensor, inplace: bool = False) -> Tensor: ...

relu_: Incomplete

def glu(input: Tensor, dim: int = -1) -> Tensor: ...
def hardtanh(input: Tensor, min_val: float = -1.0, max_val: float = 1.0, inplace: bool = False) -> Tensor: ...

hardtanh_: Incomplete

def relu6(input: Tensor, inplace: bool = False) -> Tensor: ...
def elu(input: Tensor, alpha: float = 1.0, inplace: bool = False) -> Tensor: ...

elu_: Incomplete

def selu(input: Tensor, inplace: bool = False) -> Tensor: ...

selu_: Incomplete

def celu(input: Tensor, alpha: float = 1.0, inplace: bool = False) -> Tensor: ...

celu_: Incomplete

def leaky_relu(input: Tensor, negative_slope: float = 0.01, inplace: bool = False) -> Tensor: ...

leaky_relu_: Incomplete
prelu: Incomplete

def rrelu(input: Tensor, lower: float = ..., upper: float = ..., training: bool = False, inplace: bool = False) -> Tensor: ...

rrelu_: Incomplete
logsigmoid: Incomplete
gelu: Incomplete
hardshrink: Incomplete

def tanhshrink(input): ...
def softsign(input): ...

softplus: Incomplete

def softmin(input: Tensor, dim: int | None = None, _stacklevel: int = 3, dtype: DType | None = None) -> Tensor: ...
def softmax(input: Tensor, dim: int | None = None, _stacklevel: int = 3, dtype: DType | None = None) -> Tensor: ...
def gumbel_softmax(logits: Tensor, tau: float = 1, hard: bool = False, eps: float = 1e-10, dim: int = -1) -> Tensor: ...
def log_softmax(input: Tensor, dim: int | None = None, _stacklevel: int = 3, dtype: DType | None = None) -> Tensor: ...

softshrink: Incomplete

def tanh(input): ...
def sigmoid(input): ...
def hardsigmoid(input: Tensor, inplace: bool = False) -> Tensor: ...

linear: Incomplete
bilinear: Incomplete

def silu(input: Tensor, inplace: bool = False) -> Tensor: ...
def mish(input: Tensor, inplace: bool = False) -> Tensor: ...
def hardswish(input: Tensor, inplace: bool = False) -> Tensor: ...
def embedding(input: Tensor, weight: Tensor, padding_idx: int | None = None, max_norm: float | None = None, norm_type: float = 2.0, scale_grad_by_freq: bool = False, sparse: bool = False) -> Tensor: ...
def embedding_bag(input: Tensor, weight: Tensor, offsets: Tensor | None = None, max_norm: float | None = None, norm_type: float = 2, scale_grad_by_freq: bool = False, mode: str = 'mean', sparse: bool = False, per_sample_weights: Tensor | None = None, include_last_offset: bool = False, padding_idx: int | None = None) -> Tensor: ...
def batch_norm(input: Tensor, running_mean: Tensor | None, running_var: Tensor | None, weight: Tensor | None = None, bias: Tensor | None = None, training: bool = False, momentum: float = 0.1, eps: float = 1e-05) -> Tensor: ...
def instance_norm(input: Tensor, running_mean: Tensor | None = None, running_var: Tensor | None = None, weight: Tensor | None = None, bias: Tensor | None = None, use_input_stats: bool = True, momentum: float = 0.1, eps: float = 1e-05) -> Tensor: ...
def layer_norm(input: Tensor, normalized_shape: list[int], weight: Tensor | None = None, bias: Tensor | None = None, eps: float = 1e-05) -> Tensor: ...
def rms_norm(input: Tensor, normalized_shape: list[int], weight: Tensor | None = None, eps: float | None = None) -> Tensor: ...
def group_norm(input: Tensor, num_groups: int, weight: Tensor | None = None, bias: Tensor | None = None, eps: float = 1e-05) -> Tensor: ...
def local_response_norm(input: Tensor, size: int, alpha: float = 0.0001, beta: float = 0.75, k: float = 1.0) -> Tensor: ...
def ctc_loss(log_probs: Tensor, targets: Tensor, input_lengths: Tensor, target_lengths: Tensor, blank: int = 0, reduction: str = 'mean', zero_infinity: bool = False) -> Tensor: ...
def nll_loss(input: Tensor, target: Tensor, weight: Tensor | None = None, size_average: bool | None = None, ignore_index: int = -100, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def poisson_nll_loss(input: Tensor, target: Tensor, log_input: bool = True, full: bool = False, size_average: bool | None = None, eps: float = 1e-08, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def gaussian_nll_loss(input: Tensor, target: Tensor, var: Tensor | float, full: bool = False, eps: float = 1e-06, reduction: str = 'mean') -> Tensor: ...
def kl_div(input: Tensor, target: Tensor, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean', log_target: bool = False) -> Tensor: ...
def cross_entropy(input: Tensor, target: Tensor, weight: Tensor | None = None, size_average: bool | None = None, ignore_index: int = -100, reduce: bool | None = None, reduction: str = 'mean', label_smoothing: float = 0.0) -> Tensor: ...
def binary_cross_entropy(input: Tensor, target: Tensor, weight: Tensor | None = None, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def binary_cross_entropy_with_logits(input: Tensor, target: Tensor, weight: Tensor | None = None, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean', pos_weight: Tensor | None = None) -> Tensor: ...
def smooth_l1_loss(input: Tensor, target: Tensor, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean', beta: float = 1.0) -> Tensor: ...
def huber_loss(input: Tensor, target: Tensor, reduction: str = 'mean', delta: float = 1.0, weight: Tensor | None = None) -> Tensor: ...
def l1_loss(input: Tensor, target: Tensor, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean', weight: Tensor | None = None) -> Tensor: ...
def mse_loss(input: Tensor, target: Tensor, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean', weight: Tensor | None = None) -> Tensor: ...
def margin_ranking_loss(input1: Tensor, input2: Tensor, target: Tensor, margin: float = 0, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def hinge_embedding_loss(input: Tensor, target: Tensor, margin: float = 1.0, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def multilabel_margin_loss(input: Tensor, target: Tensor, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def soft_margin_loss(input: Tensor, target: Tensor, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def multilabel_soft_margin_loss(input: Tensor, target: Tensor, weight: Tensor | None = None, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def cosine_embedding_loss(input1: Tensor, input2: Tensor, target: Tensor, margin: float = 0, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def multi_margin_loss(input: Tensor, target: Tensor, p: int = 1, margin: float = 1.0, weight: Tensor | None = None, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...

pixel_shuffle: Incomplete
pixel_unshuffle: Incomplete
channel_shuffle: Incomplete
native_channel_shuffle: Incomplete
GRID_SAMPLE_INTERPOLATION_MODES: Incomplete
GRID_SAMPLE_PADDING_MODES: Incomplete

def grid_sample(input: Tensor, grid: Tensor, mode: str = 'bilinear', padding_mode: str = 'zeros', align_corners: bool | None = None) -> Tensor: ...
def affine_grid(theta: Tensor, size: list[int], align_corners: bool | None = None) -> Tensor: ...
def pad(input: Tensor, pad: list[int], mode: str = 'constant', value: float | None = None) -> Tensor: ...

pairwise_distance: Incomplete
pdist: Incomplete
cosine_similarity: Incomplete
one_hot: Incomplete

def triplet_margin_loss(anchor: Tensor, positive: Tensor, negative: Tensor, margin: float = 1.0, p: float = 2, eps: float = 1e-06, swap: bool = False, size_average: bool | None = None, reduce: bool | None = None, reduction: str = 'mean') -> Tensor: ...
def triplet_margin_with_distance_loss(anchor: Tensor, positive: Tensor, negative: Tensor, *, distance_function: Callable[[Tensor, Tensor], Tensor] | None = None, margin: float = 1.0, swap: bool = False, reduction: str = 'mean') -> Tensor: ...
def normalize(input: Tensor, p: float = 2.0, dim: int = 1, eps: float = 1e-12, out: Tensor | None = None) -> Tensor: ...
def assert_int_or_pair(arg: list[int], arg_name: str, message: str) -> None: ...
def unfold(input: Tensor, kernel_size: BroadcastingList2[int], dilation: BroadcastingList2[int] = 1, padding: BroadcastingList2[int] = 0, stride: BroadcastingList2[int] = 1) -> Tensor: ...
def fold(input: Tensor, output_size: BroadcastingList2[int], kernel_size: BroadcastingList2[int], dilation: BroadcastingList2[int] = 1, padding: BroadcastingList2[int] = 0, stride: BroadcastingList2[int] = 1) -> Tensor: ...

scaled_dot_product_attention: Incomplete

def multi_head_attention_forward(query: Tensor, key: Tensor, value: Tensor, embed_dim_to_check: int, num_heads: int, in_proj_weight: Tensor | None, in_proj_bias: Tensor | None, bias_k: Tensor | None, bias_v: Tensor | None, add_zero_attn: bool, dropout_p: float, out_proj_weight: Tensor, out_proj_bias: Tensor | None, training: bool = True, key_padding_mask: Tensor | None = None, need_weights: bool = True, attn_mask: Tensor | None = None, use_separate_proj_weight: bool = False, q_proj_weight: Tensor | None = None, k_proj_weight: Tensor | None = None, v_proj_weight: Tensor | None = None, static_k: Tensor | None = None, static_v: Tensor | None = None, average_attn_weights: bool = True, is_causal: bool = False) -> tuple[Tensor, Tensor | None]: ...
