import torch
from _typeshed import Incomplete
from torch import Tensor as Tensor

def calculate_gain(nonlinearity, param: Incomplete | None = None): ...
def uniform_(tensor: Tensor, a: float = 0.0, b: float = 1.0, generator: torch.Generator | None = None) -> Tensor: ...
def normal_(tensor: Tensor, mean: float = 0.0, std: float = 1.0, generator: torch.Generator | None = None) -> Tensor: ...
def trunc_normal_(tensor: Tensor, mean: float = 0.0, std: float = 1.0, a: float = -2.0, b: float = 2.0, generator: torch.Generator | None = None) -> Tensor: ...
def constant_(tensor: Tensor, val: float) -> Tensor: ...
def ones_(tensor: Tensor) -> Tensor: ...
def zeros_(tensor: Tensor) -> Tensor: ...
def eye_(tensor): ...
def dirac_(tensor, groups: int = 1): ...
def xavier_uniform_(tensor: Tensor, gain: float = 1.0, generator: torch.Generator | None = None) -> Tensor: ...
def xavier_normal_(tensor: Tensor, gain: float = 1.0, generator: torch.Generator | None = None) -> Tensor: ...
def kaiming_uniform_(tensor: Tensor, a: float = 0, mode: str = 'fan_in', nonlinearity: str = 'leaky_relu', generator: torch.Generator | None = None): ...
def kaiming_normal_(tensor: Tensor, a: float = 0, mode: str = 'fan_in', nonlinearity: str = 'leaky_relu', generator: torch.Generator | None = None): ...
def orthogonal_(tensor, gain: int = 1, generator: torch.Generator | None = None): ...
def sparse_(tensor, sparsity, std: float = 0.01, generator: torch.Generator | None = None): ...

uniform: Incomplete
normal: Incomplete
constant: Incomplete
eye: Incomplete
dirac: Incomplete
xavier_uniform: Incomplete
xavier_normal: Incomplete
kaiming_uniform: Incomplete
kaiming_normal: Incomplete
orthogonal: Incomplete
sparse: Incomplete
