import os
import torch
from . import errors as errors, symbolic_caffe2 as symbolic_caffe2, symbolic_helper as symbolic_helper, symbolic_opset10 as symbolic_opset10, symbolic_opset11 as symbolic_opset11, symbolic_opset12 as symbolic_opset12, symbolic_opset13 as symbolic_opset13, symbolic_opset14 as symbolic_opset14, symbolic_opset15 as symbolic_opset15, symbolic_opset16 as symbolic_opset16, symbolic_opset17 as symbolic_opset17, symbolic_opset18 as symbolic_opset18, symbolic_opset19 as symbolic_opset19, symbolic_opset20 as symbolic_opset20, symbolic_opset7 as symbolic_opset7, symbolic_opset8 as symbolic_opset8, symbolic_opset9 as symbolic_opset9, utils as utils
from ._internal._exporter_legacy import DiagnosticOptions as DiagnosticOptions, ExportOptions as ExportOptions, ONNXRuntimeOptions as ONNXRuntimeOptions, OnnxRegistry as OnnxRegistry, enable_fake_mode as enable_fake_mode
from ._internal.exporter._onnx_program import ONNXProgram as ONNXProgram
from ._internal.onnxruntime import is_onnxrt_backend_supported as is_onnxrt_backend_supported
from ._type_utils import JitScalarType as JitScalarType
from .errors import OnnxExporterError as OnnxExporterError
from .utils import is_in_onnx_export as is_in_onnx_export, register_custom_op_symbolic as register_custom_op_symbolic, select_model_mode_for_export as select_model_mode_for_export, unregister_custom_op_symbolic as unregister_custom_op_symbolic
from torch._C import _onnx as _C_onnx
from torch._C._onnx import OperatorExportTypes as OperatorExportTypes, TensorProtoDataType as TensorProtoDataType, TrainingMode as TrainingMode
from typing import Any, Callable, Collection, Mapping, Sequence

__all__ = ['symbolic_helper', 'utils', 'errors', 'symbolic_caffe2', 'symbolic_opset7', 'symbolic_opset8', 'symbolic_opset9', 'symbolic_opset10', 'symbolic_opset11', 'symbolic_opset12', 'symbolic_opset13', 'symbolic_opset14', 'symbolic_opset15', 'symbolic_opset16', 'symbolic_opset17', 'symbolic_opset18', 'symbolic_opset19', 'symbolic_opset20', 'OperatorExportTypes', 'TrainingMode', 'TensorProtoDataType', 'JitScalarType', 'export', 'is_in_onnx_export', 'select_model_mode_for_export', 'register_custom_op_symbolic', 'unregister_custom_op_symbolic', 'OnnxExporterError', 'DiagnosticOptions', 'ExportOptions', 'ONNXProgram', 'ONNXRuntimeOptions', 'OnnxRegistry', 'dynamo_export', 'enable_fake_mode', 'is_onnxrt_backend_supported']

def export(model: torch.nn.Module | torch.export.ExportedProgram | torch.jit.ScriptModule | torch.jit.ScriptFunction, args: tuple[Any, ...] = (), f: str | os.PathLike | None = None, *, kwargs: dict[str, Any] | None = None, export_params: bool = True, verbose: bool | None = None, input_names: Sequence[str] | None = None, output_names: Sequence[str] | None = None, opset_version: int | None = None, dynamic_axes: Mapping[str, Mapping[int, str]] | Mapping[str, Sequence[int]] | None = None, keep_initializers_as_inputs: bool = False, dynamo: bool = False, external_data: bool = True, dynamic_shapes: dict[str, Any] | tuple[Any, ...] | list[Any] | None = None, custom_translation_table: dict[Callable, Callable | Sequence[Callable]] | None = None, report: bool = False, optimize: bool = False, verify: bool = False, profile: bool = False, dump_exported_program: bool = False, artifacts_dir: str | os.PathLike = '.', fallback: bool = False, training: _C_onnx.TrainingMode = ..., operator_export_type: _C_onnx.OperatorExportTypes = ..., do_constant_folding: bool = True, custom_opsets: Mapping[str, int] | None = None, export_modules_as_functions: bool | Collection[type[torch.nn.Module]] = False, autograd_inlining: bool = True, **_: Any) -> ONNXProgram | None: ...
def dynamo_export(model: torch.nn.Module | Callable | torch.export.ExportedProgram, /, *model_args, export_options: ExportOptions | None = None, **model_kwargs) -> ONNXProgram: ...
